/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * TopicPage
 */

public class TopicPage {
  @JsonProperty("data")
  private List<Topic> data = null;

  @JsonProperty("facets")
  private Object facets = null;

  @JsonProperty("next_page")
  private String nextPage = null;

  @JsonProperty("page")
  private Integer page = null;

  @JsonProperty("page_size")
  private Integer pageSize = null;

  @JsonProperty("previous_page")
  private String previousPage = null;

  @JsonProperty("total")
  private Integer total = null;

  public TopicPage data(List<Topic> data) {
    this.data = data;
    return this;
  }

  public TopicPage addDataItem(Topic dataItem) {
    if (this.data == null) {
      this.data = new ArrayList<Topic>();
    }
    this.data.add(dataItem);
    return this;
  }

   /**
   * The page data
   * @return data
  **/
  @ApiModelProperty(value = "The page data")
  public List<Topic> getData() {
    return data;
  }

  public void setData(List<Topic> data) {
    this.data = data;
  }

  public TopicPage facets(Object facets) {
    this.facets = facets;
    return this;
  }

   /**
   * Search facets results if any
   * @return facets
  **/
  @ApiModelProperty(value = "Search facets results if any")
  public Object getFacets() {
    return facets;
  }

  public void setFacets(Object facets) {
    this.facets = facets;
  }

  public TopicPage nextPage(String nextPage) {
    this.nextPage = nextPage;
    return this;
  }

   /**
   * The next page URL if exists
   * @return nextPage
  **/
  @ApiModelProperty(value = "The next page URL if exists")
  public String getNextPage() {
    return nextPage;
  }

  public void setNextPage(String nextPage) {
    this.nextPage = nextPage;
  }

  public TopicPage page(Integer page) {
    this.page = page;
    return this;
  }

   /**
   * The current page
   * minimum: 1
   * @return page
  **/
  @ApiModelProperty(required = true, value = "The current page")
  public Integer getPage() {
    return page;
  }

  public void setPage(Integer page) {
    this.page = page;
  }

  public TopicPage pageSize(Integer pageSize) {
    this.pageSize = pageSize;
    return this;
  }

   /**
   * The page size used for pagination
   * minimum: 0
   * @return pageSize
  **/
  @ApiModelProperty(required = true, value = "The page size used for pagination")
  public Integer getPageSize() {
    return pageSize;
  }

  public void setPageSize(Integer pageSize) {
    this.pageSize = pageSize;
  }

  public TopicPage previousPage(String previousPage) {
    this.previousPage = previousPage;
    return this;
  }

   /**
   * The previous page URL if exists
   * @return previousPage
  **/
  @ApiModelProperty(value = "The previous page URL if exists")
  public String getPreviousPage() {
    return previousPage;
  }

  public void setPreviousPage(String previousPage) {
    this.previousPage = previousPage;
  }

  public TopicPage total(Integer total) {
    this.total = total;
    return this;
  }

   /**
   * The total paginated items
   * minimum: 0
   * @return total
  **/
  @ApiModelProperty(required = true, value = "The total paginated items")
  public Integer getTotal() {
    return total;
  }

  public void setTotal(Integer total) {
    this.total = total;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TopicPage topicPage = (TopicPage) o;
    return Objects.equals(this.data, topicPage.data) &&
        Objects.equals(this.facets, topicPage.facets) &&
        Objects.equals(this.nextPage, topicPage.nextPage) &&
        Objects.equals(this.page, topicPage.page) &&
        Objects.equals(this.pageSize, topicPage.pageSize) &&
        Objects.equals(this.previousPage, topicPage.previousPage) &&
        Objects.equals(this.total, topicPage.total);
  }

  @Override
  public int hashCode() {
    return Objects.hash(data, facets, nextPage, page, pageSize, previousPage, total);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TopicPage {\n");

    sb.append("    data: ").append(toIndentedString(data)).append("\n");
    sb.append("    facets: ").append(toIndentedString(facets)).append("\n");
    sb.append("    nextPage: ").append(toIndentedString(nextPage)).append("\n");
    sb.append("    page: ").append(toIndentedString(page)).append("\n");
    sb.append("    pageSize: ").append(toIndentedString(pageSize)).append("\n");
    sb.append("    previousPage: ").append(toIndentedString(previousPage)).append("\n");
    sb.append("    total: ").append(toIndentedString(total)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

